#!/bin/bash

if [ -f /sys/kernel/security/kysec/status ];then
	kstatus=`cat /sys/kernel/security/kysec/status`
	if [ $kstatus -eq 2 ];then
		echo "2" > /etc/kysec/kysec_s
		if [ `echo $?` -ne 0 ];then
			echo "kysec的状态记录失败"
			echo "2" > /etc/kysec/kysec_s
		else
			echo "4" > /sys/kernel/security/kysec/status
			if [ `echo $?` -ne 0 ];then
				echo "kysec设置软模式失败"
				echo "4" > /sys/kernel/security/kysec/status
			fi
		fi
	fi
fi

if [ -f  /sys/kernel/security/kysec/iptables ];then
	iptable_status=`cat /sys/kernel/security/kysec/iptables`
	if [ $iptable_status -eq 1 ];then
		echo "1" > /etc/kysec/iptable_s
		if [ `echo $?` -ne 0 ];then
			echo "防火墙的状态记录失败"
			echo "1" > /etc/kysec/iptable_s
		else
			echo "0" > /sys/kernel/security/kysec/iptables
			if [ `echo $?` -ne 0 ];then
				echo "iptable状态设置失败"
				echo "0" > /sys/kernel/security/kysec/iptables
			fi
		fi
	fi
fi

if [ -f  /sys/kernel/security/kysec/ppro ];then
	ppro_status=`cat /sys/kernel/security/kysec/ppro`
	if [ $ppro_status -eq 1 ];then
		echo "1" > /etc/kysec/ppro_s
		if [ `echo $?` -ne 0 ];then
			echo "进程保护的状态记录失败"
			echo "1" > /etc/kysec/ppro_s
		else
			echo "0" > /sys/kernel/security/kysec/ppro
			if [ `echo $?` -ne 0 ];then
				echo "进程保护的状态设置失败"
				echo "0" > /sys/kernel/security/kysec/ppro
			fi
		fi
	fi
fi

# 检查root密码是否过期
current_date=$(date +'%Y%m%d')
expire_date_str=$(LC_ALL="C" chage -l root | grep 'Password expires' | cut -d':' -f 2)
# 过滤未设置密码过期时间的情况
if ! [[ "${expire_date_str}" =~ .*never.* ]];then
	expire_date=$(date -d "${expire_date_str}" +"%Y%m%d")
	if [ "${current_date}" -gt "${expire_date}" ];then
		# 已过期
		chage -M -1 root
	fi
fi
